########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    4 chars;
########    #######    ########    #######    ########    ########
module ArchestryLookup
  class << self

    #Gems
    require 'json'
    require 'oj'
    require 'logger'
    require 'digest'

    #Files      
    def run(state)
      ['tooling', 'sql', 'objects', 'schema', "context/#{state[:myAppName].downcase}"].each do  |folderName|
        Dir[File.join(__dir__, "#{folderName}/**", '*.rb')].each { |file| require_relative file}                                
      end
      
      args = ArchestryLookup::Schema.getMFVSchema
      state[:timing] = Process.clock_gettime(Process::CLOCK_MONOTONIC)

      ArchestryLookup::Sql.preSql(state)
      ArchestryLookup::Sql.archestry_model_lookup(args, state)
      ArchestryLookup::Objects.lookup_post(args, state)
            
      if state[:json] == 'obj'
        return args
      else
        json = JSON.pretty_generate(args) #json = Oj.dump(args) ## NO GIT-PREFERRED PRETTY OUTPUT IN OJ
        FileUtils.rm("#{state[:json]}")
        FileUtils.mkdir_p("#{state[:jsonFolder]}")          
        File.open(state[:json], 'w') { |file| file.write(json) }
      end      
    end
      
  end
end
