########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    4 chars;
########    #######    ########    #######    ########    ########
module ArchestryLookup
  module Sql
    class << self

  
      
      def preSql(state)
        state[:db] = {}

        case state[:dbtype]
        when :sqlite
          require 'sqlite3'
          db = state[:dbprop][:filepath]
          state[:db][:handler] = SQLite3::Database.new db
        when :pg
          require 'pg'
          state[:db][:handler] = PG.connect( dbname: state[:dbprop][:database])
        else
          state[:dbtype] = :sqlite
          require 'sqlite3'
          db = "/tmp/archestry.sqlite"
          state[:db][:handler] = SQLite3::Database.new db          
        end
          
        case state[:myAppName]
        when 'Dialog'
          state[:db][:relSQL] = "and relationships.class in ('AggregationRelationship', 'TriggeringRelationship', 'FlowRelationship', 'AccessRelationship', 'SpecializationRelationship', 'CompositionRelationship', 'ServingRelationship', 'RealizationRelationship')"
          state[:db][:elementsSQL] = "and (elements.class LIKE 'Application%' OR elements.class in ('DataObject', 'Grouping'))"
          state[:db][:propSQL] = "AND properties.name LIKE 'fqn'"
        when 'Archestry'
          state[:db][:relSQL] = " "
          state[:db][:elementsSQL] = ""
          state[:db][:propSQL] = ""
        end
        
      end
      
    end
  end
end
